Edje Part
Edje » Edje Object

Functions that deal with layout components. More...

## Topics

| Edje Text Part
| Functions that deal with parts of type text.
| Edje Swallow Part
| Functions that deal with parts of type swallow and swallowed objects.
| Edje Box Part
| Functions that deal with parts of type box.
| Edje Table Part
| Functions that deal with parts of type table.
| Edje Drag
| Functions that deal with dragable parts.

## Typedefs

typedef enum _Edje_Part_Type | Edje_Part_Type
| All possible "part" types in Edje.

## Enumerations

enum

_Edje_Part_Type {
EDJE_PART_TYPE_NONE = 0 ,
EDJE_PART_TYPE_RECTANGLE = 1 ,
EDJE_PART_TYPE_TEXT = 2 ,
EDJE_PART_TYPE_IMAGE = 3 ,
EDJE_PART_TYPE_SWALLOW = 4 ,
EDJE_PART_TYPE_TEXTBLOCK = 5 ,
EDJE_PART_TYPE_GRADIENT = 6 ,
EDJE_PART_TYPE_GROUP = 7 ,
EDJE_PART_TYPE_BOX = 8 ,
EDJE_PART_TYPE_TABLE = 9 ,
EDJE_PART_TYPE_EXTERNAL = 10 ,
EDJE_PART_TYPE_PROXY = 11 ,
EDJE_PART_TYPE_SPACER = 12 ,
EDJE_PART_TYPE_MESH_NODE = 13 ,
EDJE_PART_TYPE_LIGHT = 14 ,
EDJE_PART_TYPE_CAMERA = 15 ,
EDJE_PART_TYPE_SNAPSHOT = 16 ,
EDJE_PART_TYPE_VECTOR = 17 ,
EDJE_PART_TYPE_LAST = 18
}

## Functions

Eina_Bool | edje_object_part_swallow (Evas_Object *obj, const char *part, Evas_Object *obj_swallow)
| "Swallows" an object into one of the Edje object `SWALLOW` parts.
Evas_Object * | edje_object_part_swallow_get (const Evas_Object *obj, const char *part)
| Gets the object currently swallowed by a part.
void | edje_object_part_unswallow (Evas_Object *obj, Evas_Object *obj_swallow)
| Unswallows an object.
Eina_List * | edje_object_access_part_list_get (const Evas_Object *obj)
| Retrieves a list all accessibility part names.
Eina_Bool | edje_object_part_box_append (Evas_Object *obj, const char *part, Evas_Object *child)
| Appends an object to the box.
Eina_Bool | edje_object_part_box_prepend (Evas_Object *obj, const char *part, Evas_Object *child)
| Prepends an object to the box.
Eina_Bool | edje_object_part_box_insert_before (Evas_Object *obj, const char *part, Evas_Object *child, const Evas_Object *reference)
| Adds an object to the box.
Eina_Bool | edje_object_part_box_insert_at (Evas_Object *obj, const char *part, Evas_Object *child, unsigned int pos)
| Inserts an object to the box.
Evas_Object * | edje_object_part_box_remove_at (Evas_Object *obj, const char *part, unsigned int pos)
| Removes an object from the box.
Evas_Object * | edje_object_part_box_remove (Evas_Object *obj, const char *part, Evas_Object *child)
| Removes an object from the box.
Eina_Bool | edje_object_part_box_remove_all (Evas_Object *obj, const char *part, Eina_Bool clear)
| Removes all elements from the box.
Eina_Bool | edje_object_part_table_pack (Evas_Object *obj, const char *part, Evas_Object *child_obj, unsigned short col, unsigned short row, unsigned short colspan, unsigned short rowspan)
| Packs an object into the table.
Eina_Bool | edje_object_part_table_unpack (Evas_Object *obj, const char *part, Evas_Object *child_obj)
| Removes an object from the table.
Eina_Bool | edje_object_part_table_col_row_size_get (const Evas_Object *obj, const char *part, int *cols, int *rows)
| Gets the number of columns and rows the table has.
Evas_Object * | edje_object_part_table_child_get (const Evas_Object *obj, const char *part, unsigned int col, unsigned int row)
| Retrieves a child from a table.
Eina_Bool | edje_object_part_table_clear (Evas_Object *obj, const char *part, Eina_Bool clear)
| Removes all object from the table.
void | edje_object_part_text_select_allow_set (const Evas_Object *obj, const char *part, Eina_Bool allow)
| Enables selection if the entry is an EXPLICIT selection mode type.
Eina_Bool | edje_object_part_text_set (const Evas_Object *obj, const char *part, const char *text)
| Sets a given text to an Edje object `TEXT` or TEXTBLOCK parts.
const char * | edje_object_part_text_get (const Evas_Object *obj, const char *part)
| Gets the text currntly set to the given part.
void | edje_object_part_text_cursor_begin_set (Evas_Object *obj, const char *part, Edje_Cursor cur)
| Moves the cursor to the beginning of the text part evas_textblock_cursor_paragraph_first.
void | edje_object_part_text_cursor_end_set (Evas_Object *obj, const char *part, Edje_Cursor cur)
| Moves the cursor to the end of the text part.
void | edje_object_part_text_cursor_pos_set (Evas_Object *obj, const char *part, Edje_Cursor cur, int pos)
| Sets the cursor position to the given value.
int | edje_object_part_text_cursor_pos_get (const Evas_Object *obj, const char *part, Edje_Cursor cur)
| Retrieves the current position of the cursor.
Eina_Bool | edje_object_part_text_cursor_coord_set (Evas_Object *obj, const char *part, Edje_Cursor cur, int x, int y)
| Position the given cursor to a X,Y position.
void | edje_object_part_text_cursor_line_begin_set (Evas_Object *obj, const char *part, Edje_Cursor cur)
| Moves the cursor to the beginning of the line.
void | edje_object_part_text_cursor_line_end_set (Evas_Object *obj, const char *part, Edje_Cursor cur)
| Moves the cursor to the end of the line.
Eina_Bool | edje_object_part_text_cursor_prev (Evas_Object *obj, const char *part, Edje_Cursor cur)
| Moves the cursor to the previous char evas_textblock_cursor_char_prev.
Eina_Bool | edje_object_part_text_cursor_next (Evas_Object *obj, const char *part, Edje_Cursor cur)
| Advances the cursor to the next cursor position.
Eina_Bool | edje_object_part_text_cursor_up (Evas_Object *obj, const char *part, Edje_Cursor cur)
| Moves the cursor to the char above the current cursor position.
Eina_Bool | edje_object_part_text_cursor_down (Evas_Object *obj, const char *part, Edje_Cursor cur)
| Moves the cursor to the char below the current cursor position.
void | edje_object_part_text_cursor_copy (Evas_Object *obj, const char *part, Edje_Cursor src, Edje_Cursor dst)
| Copies the cursor to another cursor.
char * | edje_object_part_text_cursor_content_get (const Evas_Object *obj, const char *part, Edje_Cursor cur)
| Returns the content (char) at the cursor position.
void | edje_object_part_text_cursor_geometry_get (const Evas_Object *obj, const char *part, int *x, int *y, int *w, int *h)
| Returns the cursor geometry of the part relative to the edje object.
Eina_Bool | edje_object_part_text_hide_visible_password (Evas_Object *obj, const char *part)
| Hides visible last character for password mode.
Eina_Bool | edje_object_part_text_cursor_is_format_get (const Evas_Object *obj, const char *part, Edje_Cursor cur)
| Returns whether the cursor points to a format.
Eina_Bool | edje_object_part_text_cursor_is_visible_format_get (const Evas_Object *obj, const char *part, Edje_Cursor cur)
| Returns `true` if the cursor points to a visible format For example \t, \n, item and etc.
const Eina_List * | edje_object_part_text_anchor_geometry_get (const Evas_Object *obj, const char *part, const char *anchor)
| Returns a list of Evas_Textblock_Rectangle anchor rectangles.
const Eina_List * | edje_object_part_text_anchor_list_get (const Evas_Object *obj, const char *part)
| Returns a list of char anchor names.
const char * | edje_object_part_text_style_user_peek (const Evas_Object *obj, const char *part)
| Returns the text of the object part.
void | edje_object_part_text_style_user_push (Evas_Object *obj, const char *part, const char *style)
| Sets the style of the.
void | edje_object_part_text_style_user_pop (Evas_Object *obj, const char *part)
| Deletes the top style form the user style stack.
Eina_Bool | edje_object_part_text_item_geometry_get (const Evas_Object *obj, const char *part, const char *item, int *cx, int *cy, int *cw, int *ch)
| Returns item geometry.
const Eina_List * | edje_object_part_text_item_list_get (const Evas_Object *obj, const char *part)
| Returns a list of char item names.
void | edje_object_part_text_user_insert (const Evas_Object *obj, const char *part, const char *text)
| This function inserts text as if the user has inserted it.
void | edje_object_part_text_append (Evas_Object *obj, const char *part, const char *text)
| Inserts text for an object part.
Eina_Bool | edje_object_part_text_escaped_set (Evas_Object *obj, const char *part, const char *text)
| Sets the text for an object part, but converts HTML escapes to UTF8.
Eina_Bool | edje_object_part_text_unescaped_set (Evas_Object *obj, const char *part, const char *text_to_escape)
| Sets the raw (non escaped) text for an object part.
char * | edje_object_part_text_unescaped_get (const Evas_Object *obj, const char *part)
| Returns the text of the object part, without escaping.
void | edje_object_part_text_insert (Evas_Object *obj, const char *part, const char *text)
| Inserts text for an object part.
void | edje_object_part_text_autocapital_type_set (Evas_Object *obj, const char *part, Edje_Text_Autocapital_Type autocapital_type)
| Sets the autocapitalization type on the immodule.
Edje_Text_Autocapital_Type | edje_object_part_text_autocapital_type_get (const Evas_Object *obj, const char *part)
| Retrieves the autocapitalization type.
void | edje_object_part_text_prediction_allow_set (Evas_Object *obj, const char *part, Eina_Bool prediction)
| Sets whether the prediction is allowed or not.
Eina_Bool | edje_object_part_text_prediction_allow_get (const Evas_Object *obj, const char *part)
| Gets whether the prediction is allowed or not.
void * | edje_object_part_text_imf_context_get (const Evas_Object *obj, const char *part)
| Gets the input method context in entry.
void | edje_object_part_text_imf_context_reset (const Evas_Object *obj, const char *part)
| Resets the input method context if needed.
void | edje_object_part_text_input_hint_set (Evas_Object *obj, const char *part, Edje_Input_Hints input_hints)
| Sets the input hint which allows input methods to fine-tune their behavior.
Edje_Input_Hints | edje_object_part_text_input_hint_get (const Evas_Object *obj, const char *part)
| Gets the value of input hint.
void | edje_object_part_text_input_panel_show (const Evas_Object *obj, const char *part)
| Shows the input panel (virtual keyboard) based on the input panel property such as layout, autocapital types, and so on.
void | edje_object_part_text_input_panel_hide (const Evas_Object *obj, const char *part)
| Hides the input panel (virtual keyboard).
void | edje_object_part_text_input_panel_imdata_set (Evas_Object *obj, const char *part, const void *data, int len)
| Sets the input panel-specific data to deliver to the input panel.
void | edje_object_part_text_input_panel_imdata_get (const Evas_Object *obj, const char *part, void *data, int *len)
| Gets the specific data of the current active input panel.
void | edje_object_part_text_input_panel_layout_set (Evas_Object *obj, const char *part, Edje_Input_Panel_Layout layout)
| Sets the layout of the input panel.
Edje_Input_Panel_Layout | edje_object_part_text_input_panel_layout_get (const Evas_Object *obj, const char *part)
| Gets the layout of the input panel.
void | edje_object_part_text_input_panel_language_set (Evas_Object *obj, const char *part, Edje_Input_Panel_Lang lang)
| Sets the language mode of the input panel.
Edje_Input_Panel_Lang | edje_object_part_text_input_panel_language_get (const Evas_Object *obj, const char *part)
| Gets the language mode of the input panel.
void | edje_object_part_text_input_panel_layout_variation_set (Evas_Object *obj, const char *part, int variation)
| Sets the layout variation of the input panel.
int | edje_object_part_text_input_panel_layout_variation_get (const Evas_Object *obj, const char *part)
| Gets the layout variation of the input panel.
void | edje_object_part_text_input_panel_enabled_set (Evas_Object *obj, const char *part, Eina_Bool enabled)
| Sets the attribute to show the input panel automatically.
Eina_Bool | edje_object_part_text_input_panel_enabled_get (const Evas_Object *obj, const char *part)
| Retrieves the attribute to show the input panel automatically.
void | edje_object_part_text_input_panel_return_key_disabled_set (Evas_Object *obj, const char *part, Eina_Bool disabled)
| Sets the return key on the input panel to be disabled.
Eina_Bool | edje_object_part_text_input_panel_return_key_disabled_get (const Evas_Object *obj, const char *part)
| Gets whether the return key on the input panel should be disabled or not.
void | edje_object_part_text_input_panel_return_key_type_set (Evas_Object *obj, const char *part, Edje_Input_Panel_Return_Key_Type return_key_type)
| Sets the "return" key type.
Edje_Input_Panel_Return_Key_Type | edje_object_part_text_input_panel_return_key_type_get (const Evas_Object *obj, const char *part)
| Gets the "return" key type.
void | edje_object_part_text_input_panel_show_on_demand_set (Evas_Object *obj, const char *part, Eina_Bool ondemand)
| Sets the attribute to show the input panel in case of only a user's explicit Mouse Up event.
Eina_Bool | edje_object_part_text_input_panel_show_on_demand_get (const Evas_Object *obj, const char *part)
| Gets the attribute to show the input panel in case of only a user's explicit Mouse Up event.
void | edje_object_part_text_prediction_hint_set (Evas_Object *obj, const char *part, const char *prediction_hint)
| Sets the prediction hint to use an intelligent reply suggestion service.
Eina_Bool | edje_object_part_text_prediction_hint_hash_set (Evas_Object *obj, const char *part, const char *key, const char *value)
| Sets the prediction hint data at the specified key.
Eina_Bool | edje_object_part_text_prediction_hint_hash_del (Evas_Object *obj, const char *part, const char *key)
| Removes the prediction hint data identified by a key.
void | edje_object_part_text_select_begin (const Evas_Object *obj, const char *part)
| Starts selecting at current cursor position.
void | edje_object_part_text_select_abort (const Evas_Object *obj, const char *part)
| Aborts any selection action on a part.
void | edje_object_part_text_select_extend (const Evas_Object *obj, const char *part)
| Extends the current selection to the current cursor position.
void | edje_object_part_text_select_all (const Evas_Object *obj, const char *part)
| Sets the selection to be everything.
void | edje_object_part_text_select_none (const Evas_Object *obj, const char *part)
| Sets the selection to be none.
const char * | edje_object_part_text_selection_get (const Evas_Object *obj, const char *part)
| Returns the selection text of the object part.
Eina_Bool | edje_object_part_exists (const Evas_Object *obj, const char *part)
| Checks if a part exists in a given Edje object's group definition.
Edje_External_Param_Type | edje_object_part_external_param_type_get (const Evas_Object *obj, const char *part, const char *param)
| @addgroup Edje_Object_Group
Eina_Bool | edje_object_part_external_param_set (Evas_Object *obj, const char *part, const Edje_External_Param *param)
| Sets the parameter for the external part.
Eina_Bool | edje_object_part_external_param_get (const Evas_Object *obj, const char *part, Edje_External_Param *param)
| Gets the parameter for the external part.
Evas_Object * | edje_object_part_external_object_get (const Evas_Object *obj, const char *part)
| Gets the object created by this external part.
Evas_Object * | edje_object_part_external_content_get (const Evas_Object *obj, const char *part, const char *content)
| Gets an object contained in an part of type EXTERNAL.

## Detailed Description

Functions that deal with layout components.

Parts are layout components, but as a layout, they are objects too.

There are several types of parts, these types can be divided into two main categories, the first being containers. Containers are parts that are in effect a group of elements. The second group is that of the elements, these part types may not contain others.

This section has some functions specific for some types and others that could be applied to any type.

## Enumeration Type Documentation

## _Edje_Part_Type

enum _Edje_Part_Type

Enumerator
EDJE_PART_TYPE_NONE | None type value.
EDJE_PART_TYPE_RECTANGLE | Rectangle type value.
EDJE_PART_TYPE_TEXT | Text type value.
EDJE_PART_TYPE_IMAGE | Image type value.
EDJE_PART_TYPE_SWALLOW | Swallow type value.
EDJE_PART_TYPE_TEXTBLOCK | Text block type value.
EDJE_PART_TYPE_GRADIENT | Gradient type value.
EDJE_PART_TYPE_GROUP | Group type value.
EDJE_PART_TYPE_BOX | Box type value.
EDJE_PART_TYPE_TABLE | Table type value.
EDJE_PART_TYPE_EXTERNAL | External type value.
EDJE_PART_TYPE_PROXY | Proxy type value.

EDJE_PART_TYPE_SPACER

Spacer type value.

Since
  1.7

EDJE_PART_TYPE_SNAPSHOT

Snapshot.

Since
  1.16

EDJE_PART_TYPE_VECTOR

Vector.

Since
  1.18

EDJE_PART_TYPE_LAST | Last type value.

## Function Documentation

## edje_object_part_external_param_type_get()

Edje_External_Param_Type edje_object_part_external_param_type_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | const char * | param )

@addgroup Edje_Object_Group

Facility to query the type of the given parameter of the given part.

Parameters

  [in] | part | The part name
  [in] | param | The parameter name to use

Returns
  EDJE_EXTERNAL_PARAM_TYPE_MAX on errors, or another value from Edje_External_Param_Type on success.

## edje_object_part_external_param_set()

Eina_Bool edje_object_part_external_param_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const Edje_External_Param * | param )

Sets the parameter for the external part.

Parts of type external may carry extra properties that have meanings defined by the external plugin. For instance, it may be a string that defines a button label and setting this property will change that label on the fly.

Note
  external parts have parameters set when they change states. Those parameters will never be changed by this function. The interpretation of how state_set parameters and param_set will interact is up to the external plugin.
  this function will not check if parameter value is valid using Edje_External_Param_Info minimum, maximum, valid choices and others. However these should be checked by the underlying implementation provided by the external plugin. This is done for performance reasons.

Parameters

  [in] | part | The part name
  [in] | param | The parameter details, including its name, type and actual value. This pointer should be valid, and the parameter must exist in Edje_External_Type.parameters_info, with the exact type, otherwise the operation will fail and `false` will be returned.

Returns
  `true` if everything went fine, `false` on errors.

Referenced by edje_edit_state_external_param_set().

## edje_object_part_external_param_get()

Eina_Bool edje_object_part_external_param_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | Edje_External_Param * | param )

Gets the parameter for the external part.

Parts of type external may carry extra properties that have meanings defined by the external plugin. For instance, it may be a string that defines a button label. This property can be modified by state parameters, by explicit calls to edje_object_part_external_param_set() or getting the actual object with edje_object_part_external_object_get() and calling native functions.

This function asks the external plugin what is the current value, independent on how it was set.

Parameters

  [in] | part | The part name
  [out] | param | The parameter details. It is used as both input and output variable. This pointer should be valid, and the parameter must exist in Edje_External_Type.parameters_info, with the exact type, otherwise the operation will fail and `false` will be returned.

Returns
  `true` if everything went fine and param members are filled with information, `false` on errors and param member values are not set or valid.

## edje_object_part_external_object_get()

Evas_Object * edje_object_part_external_object_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the object created by this external part.

Parts of type external creates the part object using information provided by external plugins. It's somehow like "swallow" (edje_object_part_swallow()), but it's all set automatically.

This function returns the part created by such external plugins and being currently managed by this Edje.

Note
  Almost all swallow rules apply: you should not move, resize, hide, show, set the color or clipper of such part. It's a bit more restrictive as one must never delete this object!

Parameters

  [in] | part | The part name

Returns
  The externally created object, or `null` if there is none or part is not an external.

## edje_object_part_external_content_get()

Evas_Object * edje_object_part_external_content_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | const char * | content )

Gets an object contained in an part of type EXTERNAL.

The content string must not be `null`. Its actual value depends on the code providing the EXTERNAL.

Parameters

  [in] | part | The name of the part holding the EXTERNAL
  [in] | content | A string identifying which content from the EXTERNAL to get

Returns
  Canvas object

## edje_object_part_swallow()

Eina_Bool edje_object_part_swallow | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | obj_swallow )

"Swallows" an object into one of the Edje object `SWALLOW` parts.

Swallowing an object into an Edje object is, for a given part of type `SWALLOW` in the EDC group which gave life to obj, to set an external object to be controlled by obj, being displayed exactly over that part's region inside the whole Edje object's viewport.

From this point on, obj will have total control over obj_swallow's geometry and visibility. For instance, if obj is visible, as in evas_object_show(), the swallowed object will be visible too – if the given `SWALLOW` part it's in is also visible. Other actions on obj will also reflect on the swallowed object as well (e.g. resizing, moving, raising/lowering, etc.).

Finally, all internal changes to part, specifically, will reflect on the displaying of obj_swallow, for example state changes leading to different visibility states, geometries, positions, etc.

If an object has already been swallowed into this part, then it will first be unswallowed (as in edje_object_part_unswallow()) before the new object is swallowed.

Note
  obj won't delete the swallowed object once it is deleted – obj_swallow will get to an unparented state again.

For more details on EDC `SWALLOW` parts, see syntaxreference.

Parameters

  [in] | obj_swallow | The object to occupy that part

Examples
  edje-swallow.c, emotion_test_main.c, and evas-aspect-hints.c.

References EDJE_PART_TYPE_SWALLOW, EINA_FALSE, and ERR.

Referenced by ethumb_frame_set().

## edje_object_part_swallow_get()

Evas_Object * edje_object_part_swallow_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the object currently swallowed by a part.

Parameters

  [in] | part | The part name

Returns
  The swallowed object, or `null` if there is none.

Examples
  edje-swallow.c.

References EDJE_PART_TYPE_SWALLOW, ERR, and INF.

Referenced by ethumb_frame_set().

## edje_object_part_unswallow()

void edje_object_part_unswallow | ( | Evas_Object * | obj,
|  | Evas_Object * | obj_swallow )

Unswallows an object.

Causes the edje to regurgitate a previously swallowed object. :)

Note
  obj_swallow will not be deleted or hidden. Note: obj_swallow may appear shown on the evas depending on its state when it got unswallowed. Make sure you delete it or hide it if you do not want it to.

Parameters

  [in] | obj_swallow | The swallowed object

Referenced by ethumb_frame_set().

## edje_object_access_part_list_get()

Eina_List * edje_object_access_part_list_get | ( | const Evas_Object * | obj | ) |

Retrieves a list all accessibility part names.

Returns
  A list all accessibility part names on obj

Since
  1.7.0

References EINA_ITERATOR_FOREACH, eina_iterator_free(), and eina_list_append().

## edje_object_part_box_append()

Eina_Bool edje_object_part_box_append | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child )

Appends an object to the box.

Appends child to the box indicated by part.

See also edje_object_part_box_prepend(), edje_object_part_box_insert_before(), edje_object_part_box_insert_after() and edje_object_part_box_insert_at()

Parameters

  [in] | child | The object to append

Returns
  `true:` Successfully added. `false:` An error occurred.

Examples
  edje-box.c, and edje-box2.c.

References EINA_FALSE.

## edje_object_part_box_prepend()

Eina_Bool edje_object_part_box_prepend | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child )

Prepends an object to the box.

Prepends child to the box indicated by part.

See also edje_object_part_box_append(), edje_object_part_box_insert_before(), edje_object_part_box_insert_after and edje_object_part_box_insert_at()

Parameters

  [in] | child | The object to prepend

Returns
  `true:` Successfully added. `false:` An error occurred.

References EINA_FALSE.

## edje_object_part_box_insert_before()

Eina_Bool edje_object_part_box_insert_before | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child,
|  | const Evas_Object * | reference )

Adds an object to the box.

Inserts child in the box given by part, in the position marked by reference.

See also edje_object_part_box_append(), edje_object_part_box_prepend(), edje_object_part_box_insert_after() and edje_object_part_box_insert_at()

Parameters

  [in] | child | The object to insert
  [in] | reference | The object to be used as reference

Returns
  `true:` Successfully added. `false:` An error occurred.

Examples
  edje-box.c.

References EINA_FALSE.

## edje_object_part_box_insert_at()

Eina_Bool edje_object_part_box_insert_at | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child,
|  | unsigned int | pos )

Inserts an object to the box.

Adds child to the box indicated by part, in the position given by pos.

See also edje_object_part_box_append(), edje_object_part_box_prepend(), edje_object_part_box_insert_before() and edje_object_part_box_insert_after()

Parameters

  [in] | child | The object to insert
  [in] | pos | The position where to insert child

Returns
  `true:` Successfully added. `false:` An error occurred.

Examples
  edje-box.c, and edje-box2.c.

References EINA_FALSE.

## edje_object_part_box_remove_at()

Evas_Object * edje_object_part_box_remove_at | ( | Evas_Object * | obj,
|  | const char * | part,
|  | unsigned int | pos )

Removes an object from the box.

Removes from the box indicated by part, the object in the position pos.

See also edje_object_part_box_remove() and edje_object_part_box_remove_all()

Parameters

  [in] | pos | The position index of the object (starts counting from 0)

Returns
  Pointer to the object removed, or `null`.

Examples
  edje-box2.c.

## edje_object_part_box_remove()

Evas_Object * edje_object_part_box_remove | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child )

Removes an object from the box.

Removes child from the box indicated by part.

See also edje_object_part_box_remove_at() and edje_object_part_box_remove_all()

Parameters

  [in] | child | The object to remove

Returns
  Pointer to the object removed, or `null`.

Examples
  edje-box.c.

## edje_object_part_box_remove_all()

Eina_Bool edje_object_part_box_remove_all | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Eina_Bool | clear )

Removes all elements from the box.

Removes all the external objects from the box indicated by part. Elements created from the theme will not be removed.

See also edje_object_part_box_remove() and edje_object_part_box_remove_at()

Parameters

  [in] | clear | Delete objects on removal

Returns
  1: Successfully cleared. 0: An error occurred.

Examples
  edje-box.c.

References EINA_FALSE.

## edje_object_part_table_pack()

Eina_Bool edje_object_part_table_pack | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child_obj,
|  | unsigned short | col,
|  | unsigned short | row,
|  | unsigned short | colspan,
|  | unsigned short | rowspan )

Packs an object into the table.

Packs an object into the table indicated by part.

Parameters

  [in] | child_obj | The object to pack in
  [in] | col | The column to place it in
  [in] | row | The row to place it in
  [in] | colspan | Columns the child will take
  [in] | rowspan | Rows the child will take

Returns
  `true` object was added, `false` on failure

Examples
  edje-table.c.

References EINA_FALSE.

## edje_object_part_table_unpack()

Eina_Bool edje_object_part_table_unpack | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | child_obj )

Removes an object from the table.

Removes an object from the table indicated by part.

Parameters

  [in] | child_obj | The object to pack in

Returns
  `true` object removed, `false` on failure

Examples
  edje-table.c.

References EINA_FALSE.

## edje_object_part_table_col_row_size_get()

Eina_Bool edje_object_part_table_col_row_size_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | int * | cols,
|  | int * | rows )

Gets the number of columns and rows the table has.

Retrieves the size of the table in number of columns and rows.

Parameters

  [out] | cols | Pointer where to store number of columns (can be `null`)
  [out] | rows | Pointer where to store number of rows (can be `null`)

Returns
  `true` get some data, `false` on failure

Examples
  edje-table.c.

References EINA_FALSE, and EINA_TRUE.

## edje_object_part_table_child_get()

Evas_Object * edje_object_part_table_child_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | unsigned int | col,
|  | unsigned int | row )

Retrieves a child from a table.

Parameters

  [in] | col | The column of the child to get
  [in] | row | The row of the child to get

Returns
  The child Efl.Canvas.Object

## edje_object_part_table_clear()

Eina_Bool edje_object_part_table_clear | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Eina_Bool | clear )

Removes all object from the table.

Removes all object from the table indicated by part, except the internal ones set from the theme.

Parameters

  [in] | clear | If set, will delete subobjs on remove

Returns
  `true` clear the table, `false` on failure

Examples
  edje-table.c.

References EINA_FALSE.

## edje_object_part_text_select_allow_set()

void edje_object_part_text_select_allow_set | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | Eina_Bool | allow )

Enables selection if the entry is an EXPLICIT selection mode type.

The default is to not allow selection. This function only affects user selection, functions such as edje_object_part_text_select_all() and edje_object_part_text_select_none() are not affected.

Parameters

  [in] | part | The part name
  [in] | allow | true to enable, false otherwise

Examples
  edje-text.c.

## edje_object_part_text_set()

Eina_Bool edje_object_part_text_set | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | const char * | text )

Sets a given text to an Edje object `TEXT` or TEXTBLOCK parts.

Parameters

  [in] | part | The part name
  [in] | text | The text to set on that part

Examples
  edje-color-class.c, edje-text.c, and emotion_test_main.c.

References EINA_TRUE.

## edje_object_part_text_get()

const char * edje_object_part_text_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the text currntly set to the given part.

Parameters

  [in] | part | The part name

Returns
  The text set on the part, `null` otherwise.

References EDJE_PART_TYPE_TEXT, EDJE_PART_TYPE_TEXTBLOCK, EINA_FALSE, EINA_TRUE, and ERR.

## edje_object_part_text_cursor_begin_set()

void edje_object_part_text_cursor_begin_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Moves the cursor to the beginning of the text part evas_textblock_cursor_paragraph_first.

Parameters

  [in] | part | The part name
  [in] | cur | The edje cursor to work on

References EINA_UNUSED.

## edje_object_part_text_cursor_end_set()

void edje_object_part_text_cursor_end_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Moves the cursor to the end of the text part.

evas_textblock_cursor_paragraph_last

Parameters

  [in] | part | The part name
  [in] | cur | The edje cursor to work on

References EINA_UNUSED.

## edje_object_part_text_cursor_pos_set()

void edje_object_part_text_cursor_pos_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur,
|  | int | pos )

Sets the cursor position to the given value.

Parameters

  [in] | part | The part name
  [in] | cur | The cursor to move
  [in] | pos | The position of the cursor

Since
  1.1.0

References EINA_UNUSED.

## edje_object_part_text_cursor_pos_get()

int edje_object_part_text_cursor_pos_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Retrieves the current position of the cursor.

Parameters

  [in] | part | The part name
  [in] | cur | The cursor to move

Returns
  The position of the cursor

Since
  1.1.0

References EINA_UNUSED.

## edje_object_part_text_cursor_coord_set()

Eina_Bool edje_object_part_text_cursor_coord_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur,
|  | int | x,
|  | int | y )

Position the given cursor to a X,Y position.

This is frequently used with the user cursor.

Parameters

  [in] | part | The part containing the object.
  [in] | cur | The cursor to adjust.
  [in] | x | X Coordinate.
  [in] | y | Y Coordinate.

Returns
  `true` on success, `false` otherwise

References EINA_FALSE, and EINA_UNUSED.

## edje_object_part_text_cursor_line_begin_set()

void edje_object_part_text_cursor_line_begin_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Moves the cursor to the beginning of the line.

evas_textblock_cursor_line_char_first

Parameters

  [in] | part | The part name
  [in] | cur | The edje cursor to work on

References EINA_UNUSED.

## edje_object_part_text_cursor_line_end_set()

void edje_object_part_text_cursor_line_end_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Moves the cursor to the end of the line.

evas_textblock_cursor_line_char_last

Parameters

  [in] | part | The part name
  [in] | cur | The edje cursor to work on

References EINA_UNUSED.

## edje_object_part_text_cursor_prev()

Eina_Bool edje_object_part_text_cursor_prev | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Moves the cursor to the previous char evas_textblock_cursor_char_prev.

Parameters

  [in] | part | The part name
  [in] | cur | The edje cursor to work on

Returns
  `true` on success, `false` otherwise

References EINA_FALSE, and EINA_UNUSED.

## edje_object_part_text_cursor_next()

Eina_Bool edje_object_part_text_cursor_next | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Advances the cursor to the next cursor position.

evas_textblock_cursor_char_next

Parameters

  [in] | part | The part name
  [in] | cur | The edje cursor to advance

Returns
  `true` on success, `false` otherwise

References EINA_FALSE, and EINA_UNUSED.

## edje_object_part_text_cursor_up()

Eina_Bool edje_object_part_text_cursor_up | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Moves the cursor to the char above the current cursor position.

Parameters

  [in] | part | The part name
  [in] | cur | The edje cursor to work on

Returns
  `true` on success, `false` otherwise

References EINA_FALSE, and EINA_UNUSED.

## edje_object_part_text_cursor_down()

Eina_Bool edje_object_part_text_cursor_down | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Moves the cursor to the char below the current cursor position.

Parameters

  [in] | part | The part name
  [in] | cur | The edje cursor to work on

Returns
  `true` on success, `false` otherwise

References EINA_FALSE, and EINA_UNUSED.

## edje_object_part_text_cursor_copy()

void edje_object_part_text_cursor_copy | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | src,
|  | Edje_Cursor | dst )

Copies the cursor to another cursor.

Parameters

  [in] | part | The part name
  [in] | src | The cursor to copy from
  [in] | dst | The cursor to copy to

References EINA_UNUSED.

## edje_object_part_text_cursor_content_get()

char * edje_object_part_text_cursor_content_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Returns the content (char) at the cursor position.

evas_textblock_cursor_content_get

You must free the return (if not `null`) after you are done with it.

Parameters

  [in] | part | The part name
  [in] | cur | The cursor to use

Returns
  The character string pointed to (may be a multi-byte utf8 sequence) terminated by a null byte.

References EINA_UNUSED.

## edje_object_part_text_cursor_geometry_get()

void edje_object_part_text_cursor_geometry_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | int * | x,
|  | int * | y,
|  | int * | w,
|  | int * | h )

Returns the cursor geometry of the part relative to the edje object.

Parameters

  [in] | part | The part name
  [out] | x | Cursor X position
  [out] | y | Cursor Y position
  [out] | w | Cursor width
  [out] | h | Cursor height

References EINA_UNUSED.

## edje_object_part_text_hide_visible_password()

Eina_Bool edje_object_part_text_hide_visible_password | ( | Evas_Object * | obj,
|  | const char * | part )

Hides visible last character for password mode.

Parameters

  [in] | part | The part name

Returns
  `true` if the visible character is hidden. `false` if there is no visible character or the object is not set for password mode.

Since
  1.18.0

References EDJE_PART_TYPE_TEXTBLOCK, and EINA_FALSE.

## edje_object_part_text_cursor_is_format_get()

Eina_Bool edje_object_part_text_cursor_is_format_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Returns whether the cursor points to a format.

evas_textblock_cursor_is_format

Parameters

  [in] | part | The part name
  [in] | cur | The cursor to adjust.

Returns
  `true` if the cursor points to a format, `false` otherwise.

References EINA_FALSE.

## edje_object_part_text_cursor_is_visible_format_get()

Eina_Bool edje_object_part_text_cursor_is_visible_format_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Cursor | cur )

Returns `true` if the cursor points to a visible format For example \t, \n, item and etc.

evas_textblock_cursor_format_is_visible_get

Parameters

  [in] | part | The part name
  [in] | cur | The cursor to adjust.

Returns
  `true` if the cursor points to a visible format, `false` otherwise.

References EINA_FALSE.

## edje_object_part_text_anchor_geometry_get()

const Eina_List * edje_object_part_text_anchor_geometry_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | const char * | anchor )

Returns a list of Evas_Textblock_Rectangle anchor rectangles.

This function return a list of Evas_Textblock_Rectangle anchor rectangles.

Parameters

  [in] | part | The part name
  [in] | anchor | The anchor name

Returns
  The list of anchor rects (const Evas_Textblock_Rectangle *), do not modify! Geometry is relative to entry part.

## edje_object_part_text_anchor_list_get()

const Eina_List * edje_object_part_text_anchor_list_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Returns a list of char anchor names.

This function returns a list of char anchor names.

Parameters

  [in] | part | The part name

Returns
  The list of anchors (const char *), do not modify!

## edje_object_part_text_style_user_peek()

const char * edje_object_part_text_style_user_peek | ( | const Evas_Object * | obj,
|  | const char * | part )

Returns the text of the object part.

This function returns the style associated with the textblock part.

Parameters

  [in] | part | The part name

Returns
  The text string

Since
  1.2.0

References EDJE_PART_TYPE_TEXTBLOCK, EINA_SAFETY_ON_NULL_RETURN_VAL, evas_object_textblock_style_user_peek(), and evas_textblock_style_get().

## edje_object_part_text_style_user_push()

void edje_object_part_text_style_user_push | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | style )

Sets the style of the.

This function sets the style associated with the textblock part.

Parameters

  [in] | part | The part name
  [in] | style | The style to set (textblock conventions).

Since
  1.2.0

References EDJE_PART_TYPE_TEXTBLOCK, EINA_TRUE, evas_object_textblock_style_user_push(), evas_textblock_style_free(), evas_textblock_style_new(), and evas_textblock_style_set().

Referenced by elm_textpath_text_user_style_set().

## edje_object_part_text_style_user_pop()

void edje_object_part_text_style_user_pop | ( | Evas_Object * | obj,
|  | const char * | part )

Deletes the top style form the user style stack.

Parameters

  [in] | part | The part name

Since
  1.2.0

References EDJE_PART_TYPE_TEXTBLOCK, EINA_TRUE, and evas_object_textblock_style_user_pop().

Referenced by elm_textpath_text_user_style_set().

## edje_object_part_text_item_geometry_get()

Eina_Bool edje_object_part_text_item_geometry_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | const char * | item,
|  | int * | cx,
|  | int * | cy,
|  | int * | cw,
|  | int * | ch )

Returns item geometry.

This function return a list of Evas_Textblock_Rectangle item rectangles.

Parameters

  [in] | part | The part name
  [in] | item | The item name
  [out] | cx | Item x return (relative to entry part)
  [out] | cy | Item y return (relative to entry part)
  [out] | cw | Item width return
  [out] | ch | Item height return

Returns
  $1 if item exists, $0 if not

References EINA_FALSE.

## edje_object_part_text_item_list_get()

const Eina_List * edje_object_part_text_item_list_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Returns a list of char item names.

This function returns a list of char item names.

Parameters

  [in] | part | The part name

Returns
  The list of items (const char *), do not modify!

## edje_object_part_text_user_insert()

void edje_object_part_text_user_insert | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | const char * | text )

This function inserts text as if the user has inserted it.

This means it actually registers as a change and emits signals, triggers callbacks as appropriate.

Parameters

  [in] | part | The part name
  [in] | text | The text string

Since
  1.2.0

References EINA_SAFETY_ON_NULL_RETURN.

## edje_object_part_text_append()

void edje_object_part_text_append | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | text )

Inserts text for an object part.

This function inserts the text for an object part at the end; It does not move the cursor.

Parameters

  [in] | part | The part name
  [in] | text | The text string

Since
  1.1

References EDJE_PART_TYPE_TEXTBLOCK, EINA_SAFETY_ON_NULL_RETURN, and EINA_TRUE.

## edje_object_part_text_escaped_set()

Eina_Bool edje_object_part_text_escaped_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | text )

Sets the text for an object part, but converts HTML escapes to UTF8.

This converts the given string text to UTF8 assuming it contains HTML style escapes like "&amp;" and "&copy;" etc. IF the part is of type TEXT, as opposed to TEXTBLOCK.

Parameters

  [in] | part | The part name
  [in] | text | The text string

Returns
  `true` on success, `false` otherwise

Since
  1.2

References EDJE_PART_TYPE_TEXT, EDJE_PART_TYPE_TEXTBLOCK, EINA_FALSE, EINA_SAFETY_ON_NULL_RETURN_VAL, eina_strbuf_append(), eina_strbuf_append_length(), eina_strbuf_free(), eina_strbuf_new(), eina_strbuf_string_get(), and evas_textblock_escape_string_range_get().

## edje_object_part_text_unescaped_set()

Eina_Bool edje_object_part_text_unescaped_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | text_to_escape )

Sets the raw (non escaped) text for an object part.

This function will not do escape for you if it is a TEXTBLOCK part, that is, if text contain tags, these tags will not be interpreted/parsed by TEXTBLOCK.

See also edje_object_part_text_unescaped_get().

Parameters

  [in] | part | The part name
  [in] | text_to_escape | The text string

Returns
  `true` on success, `false` otherwise

References EDJE_PART_TYPE_TEXT, EDJE_PART_TYPE_TEXTBLOCK, EINA_FALSE, and EINA_SAFETY_ON_NULL_RETURN_VAL.

## edje_object_part_text_unescaped_get()

char * edje_object_part_text_unescaped_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Returns the text of the object part, without escaping.

This function is the counterpart of edje_object_part_text_unescaped_set(). Please notice that the result is newly allocated memory and should be released with free() when done.

See also edje_object_part_text_unescaped_set().

Parameters

  [in] | part | The part name

Returns
  The text string

References EDJE_PART_TYPE_TEXT, EDJE_PART_TYPE_TEXTBLOCK, EINA_SAFETY_ON_NULL_RETURN_VAL, and evas_object_textblock_text_markup_get().

## edje_object_part_text_insert()

void edje_object_part_text_insert | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | text )

Inserts text for an object part.

This function inserts the text for an object part just before the cursor position.

Parameters

  [in] | part | The part name
  [in] | text | The text string

References EINA_SAFETY_ON_NULL_RETURN.

## edje_object_part_text_autocapital_type_set()

void edje_object_part_text_autocapital_type_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Text_Autocapital_Type | autocapital_type )

Sets the autocapitalization type on the immodule.

Parameters

  [in] | part | The part name
  [in] | autocapital_type | The type of autocapitalization

Since
  1.1.0

## edje_object_part_text_autocapital_type_get()

Edje_Text_Autocapital_Type edje_object_part_text_autocapital_type_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Retrieves the autocapitalization type.

Parameters

  [in] | part | The part name

Returns
  The type of autocapitalization

Since
  1.1.0

## edje_object_part_text_prediction_allow_set()

void edje_object_part_text_prediction_allow_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Eina_Bool | prediction )

Sets whether the prediction is allowed or not.

Parameters

  [in] | part | The part name
  [in] | prediction | If `true`, the prediction feature is allowed.

Since
  1.2.0

## edje_object_part_text_prediction_allow_get()

Eina_Bool edje_object_part_text_prediction_allow_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets whether the prediction is allowed or not.

Parameters

  [in] | part | The part name

Returns
  If `true`, the prediction feature is allowed.

Since
  1.2.0

References EINA_FALSE.

## edje_object_part_text_imf_context_get()

void * edje_object_part_text_imf_context_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the input method context in entry.

If ecore_imf was not available when edje was compiled, this function returns `null` otherwise, the returned pointer is an Ecore_IMF

Parameters

  [in] | part | The part name

Returns
  The input method context (Ecore_IMF_Context *) in entry

Since
  1.2.0

## edje_object_part_text_imf_context_reset()

void edje_object_part_text_imf_context_reset | ( | const Evas_Object * | obj,
|  | const char * | part )

Resets the input method context if needed.

This can be necessary in the case where modifying the buffer would confuse on-going input method behavior

Parameters

  [in] | part | The part name

Since
  1.2.0

## edje_object_part_text_input_hint_set()

void edje_object_part_text_input_hint_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Input_Hints | input_hints )

Sets the input hint which allows input methods to fine-tune their behavior.

Parameters

  [in] | part | The part name
  [in] | input_hints | Input hints

Since
  1.12.0

## edje_object_part_text_input_hint_get()

Edje_Input_Hints edje_object_part_text_input_hint_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the value of input hint.

Parameters

  [in] | part | The part name

Returns
  Input hints

Since
  1.12.0

References EINA_FALSE.

## edje_object_part_text_input_panel_show()

void edje_object_part_text_input_panel_show | ( | const Evas_Object * | obj,
|  | const char * | part )

Shows the input panel (virtual keyboard) based on the input panel property such as layout, autocapital types, and so on.

Note that input panel is shown or hidden automatically according to the focus state. This API can be used in the case of manually controlling by using edje_object_part_text_input_panel_enabled_set.

Parameters

  [in] | part | The part name

Since
  1.2.0

## edje_object_part_text_input_panel_hide()

void edje_object_part_text_input_panel_hide | ( | const Evas_Object * | obj,
|  | const char * | part )

Hides the input panel (virtual keyboard).

See also edje_object_part_text_input_panel_show

Note that input panel is shown or hidden automatically according to the focus state. This API can be used in the case of manually controlling by using edje_object_part_text_input_panel_enabled_set.

Parameters

  [in] | part | The part name

Since
  1.2.0

## edje_object_part_text_input_panel_imdata_set()

void edje_object_part_text_input_panel_imdata_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const void * | data,
|  | int | len )

Sets the input panel-specific data to deliver to the input panel.

This API is used by applications to deliver specific data to the input panel. The data format MUST be negotiated by both application and the input panel. The size and format of data are defined by the input panel.

Parameters

  [in] | part | The part name
  [in] | data | The specific data to be set to the input panel.
  [in] | len | The length of data, in bytes, to send to the input panel

Since
  1.2.0

## edje_object_part_text_input_panel_imdata_get()

void edje_object_part_text_input_panel_imdata_get | ( | const Evas_Object * | obj,
|  | const char * | part,
|  | void * | data,
|  | int * | len )

Gets the specific data of the current active input panel.

Parameters

  [in] | part | The part name
  [in] | data | The specific data to be set to the input panel.
  [out] | len | The length of data, in bytes, to send to the input panel

Returns
  FIXME: void needed here?

Since
  1.2.0

## edje_object_part_text_input_panel_layout_set()

void edje_object_part_text_input_panel_layout_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Input_Panel_Layout | layout )

Sets the layout of the input panel.

The layout of the input panel or virtual keyboard can make it easier or harder to enter content. This allows you to hint what kind of input you are expecting to enter and thus have the input panel automatically come up with the right mode.

Parameters

  [in] | part | The part name
  [in] | layout | Layout type of the input panel

Since
  1.1

## edje_object_part_text_input_panel_layout_get()

Edje_Input_Panel_Layout edje_object_part_text_input_panel_layout_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the layout of the input panel.

See also edje_object_part_text_input_panel_layout_set

Parameters

  [in] | part | The part name

Returns
  Layout type of the input panel

Since
  1.1

## edje_object_part_text_input_panel_language_set()

void edje_object_part_text_input_panel_language_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Input_Panel_Lang | lang )

Sets the language mode of the input panel.

This API can be used if you want to show the Alphabet keyboard.

Parameters

  [in] | part | The part name
  [in] | lang | The language to be set to the input panel.

Since
  1.2.0

## edje_object_part_text_input_panel_language_get()

Edje_Input_Panel_Lang edje_object_part_text_input_panel_language_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the language mode of the input panel.

See also edje_object_part_text_input_panel_language_set for more details.

Parameters

  [in] | part | The part name

Returns
  The language to be set to the input panel.

Since
  1.2.0

## edje_object_part_text_input_panel_layout_variation_set()

void edje_object_part_text_input_panel_layout_variation_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | int | variation )

Sets the layout variation of the input panel.

The layout variation of the input panel or virtual keyboard can make it easier or harder to enter content. This allows you to hint what kind of input you are expecting to enter and thus have the input panel automatically come up with the right mode.

Parameters

  [in] | part | The part name
  [in] | variation | Layout variation type

Since
  1.8

## edje_object_part_text_input_panel_layout_variation_get()

int edje_object_part_text_input_panel_layout_variation_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the layout variation of the input panel.

See also edje_object_part_text_input_panel_layout_variation_set

Parameters

  [in] | part | The part name

Returns
  Layout variation type

Since
  1.8

## edje_object_part_text_input_panel_enabled_set()

void edje_object_part_text_input_panel_enabled_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Eina_Bool | enabled )

Sets the attribute to show the input panel automatically.

Parameters

  [in] | part | The part name
  [in] | enabled | If `true`, the input panel is appeared when entry is clicked or has a focus

Since
  1.1.0

## edje_object_part_text_input_panel_enabled_get()

Eina_Bool edje_object_part_text_input_panel_enabled_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Retrieves the attribute to show the input panel automatically.

See also edje_object_part_text_input_panel_enabled_set

Parameters

  [in] | part | The part name

Returns
  If `true`, the input panel is appeared when entry is clicked or has a focus

Since
  1.1.0

References EINA_FALSE.

## edje_object_part_text_input_panel_return_key_disabled_set()

void edje_object_part_text_input_panel_return_key_disabled_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Eina_Bool | disabled )

Sets the return key on the input panel to be disabled.

Parameters

  [in] | part | The part name
  [in] | disabled | The state

Since
  1.2.0

## edje_object_part_text_input_panel_return_key_disabled_get()

Eina_Bool edje_object_part_text_input_panel_return_key_disabled_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets whether the return key on the input panel should be disabled or not.

Parameters

  [in] | part | The part name

Returns
  The state

Since
  1.2.0

References EINA_FALSE.

## edje_object_part_text_input_panel_return_key_type_set()

void edje_object_part_text_input_panel_return_key_type_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Edje_Input_Panel_Return_Key_Type | return_key_type )

Sets the "return" key type.

This type is used to set string or icon on the "return" key of the input panel.

An input panel displays the string or icon associated with this type

Parameters

  [in] | part | The part name
  [in] | return_key_type | The type of "return" key on the input panel

Since
  1.2.0

## edje_object_part_text_input_panel_return_key_type_get()

Edje_Input_Panel_Return_Key_Type edje_object_part_text_input_panel_return_key_type_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the "return" key type.

See also edje_object_part_text_input_panel_return_key_type_set() for more details

Parameters

  [in] | part | The part name

Returns
  The type of "return" key on the input panel

Since
  1.2.0

## edje_object_part_text_input_panel_show_on_demand_set()

void edje_object_part_text_input_panel_show_on_demand_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Eina_Bool | ondemand )

Sets the attribute to show the input panel in case of only a user's explicit Mouse Up event.

It doesn't request to show the input panel even though it has focus.

Parameters

  [in] | part | The part name
  [in] | ondemand | If `true`, the input panel will be shown in case of only Mouse up event. (Focus event will be ignored.)

Since
  1.9.0

## edje_object_part_text_input_panel_show_on_demand_get()

Eina_Bool edje_object_part_text_input_panel_show_on_demand_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Gets the attribute to show the input panel in case of only a user's explicit Mouse Up event.

Parameters

  [in] | part | The part name

Returns
  If `true`, the input panel will be shown in case of only Mouse up event. (Focus event will be ignored.)

Since
  1.9.0

References EINA_FALSE.

## edje_object_part_text_prediction_hint_set()

void edje_object_part_text_prediction_hint_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | prediction_hint )

Sets the prediction hint to use an intelligent reply suggestion service.

Parameters

  [in] | part | The part name
  [in] | prediction_hint | Prediction hint

Since
  1.20.0

## edje_object_part_text_prediction_hint_hash_set()

Eina_Bool edje_object_part_text_prediction_hint_hash_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | key,
|  | const char * | value )

Sets the prediction hint data at the specified key.

Parameters

  [in] | part | The part name
  [in] | key | The key of the prediction hint
  [in] | value | The data to replace

Returns
  `true` on success, `false` otherwise

Since
  1.21.0

References EINA_FALSE.

## edje_object_part_text_prediction_hint_hash_del()

Eina_Bool edje_object_part_text_prediction_hint_hash_del | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | key )

Removes the prediction hint data identified by a key.

Parameters

  [in] | part | The part name
  [in] | key | The key of the prediction hint

Returns
  `true` on success, `false` otherwise

Since
  1.21.0

References EINA_FALSE.

## edje_object_part_text_select_begin()

void edje_object_part_text_select_begin | ( | const Evas_Object * | obj,
|  | const char * | part )

Starts selecting at current cursor position.

Parameters

  [in] | part | The part name

## edje_object_part_text_select_abort()

void edje_object_part_text_select_abort | ( | const Evas_Object * | obj,
|  | const char * | part )

Aborts any selection action on a part.

Parameters

  [in] | part | The part name

## edje_object_part_text_select_extend()

void edje_object_part_text_select_extend | ( | const Evas_Object * | obj,
|  | const char * | part )

Extends the current selection to the current cursor position.

Parameters

  [in] | part | The part name

## edje_object_part_text_select_all()

void edje_object_part_text_select_all | ( | const Evas_Object * | obj,
|  | const char * | part )

Sets the selection to be everything.

This function selects all text of the object of the part.

Parameters

  [in] | part | The part name

Examples
  edje-text.c.

## edje_object_part_text_select_none()

void edje_object_part_text_select_none | ( | const Evas_Object * | obj,
|  | const char * | part )

Sets the selection to be none.

This function sets the selection text to be none.

Parameters

  [in] | part | The part name

Examples
  edje-text.c.

## edje_object_part_text_selection_get()

const char * edje_object_part_text_selection_get | ( | const Evas_Object * | obj,
|  | const char * | part )

Returns the selection text of the object part.

This function returns selection text of the object part.

See also edje_object_part_text_select_all() and edje_object_part_text_select_none()

Parameters

  [in] | part | The part name

Returns
  The text string

Examples
  edje-text.c.

## edje_object_part_exists()

Eina_Bool edje_object_part_exists | ( | const Evas_Object * | obj,
|  | const char * | part )

Checks if a part exists in a given Edje object's group definition.

This function returns if a given part exists in the Edje group bound to this object (with edje_object_file_set()).

This call is useful, for example, when one could expect or not a given GUI element, depending on the theme applied to the object.

Parameters

  [in] | part | The part's name to check for existence in obj's group

Returns
  `true` if the Edje part exists in obj's group, or `false` otherwise (and on errors)